


'(
' ------------------------------------------------------------------------------
' Author :     Dietmar Steiner
' Projekt:     Temperaturmessung und Regelung mit Dallas DS1820
'              fr Aquarien mit Boden und/oder Wasser(Stab)heizer.
'              Mit LCD - Anzeige und Tastatur
'
' Controller:  Atmel Atmega16L, interner 8MHZ RC Oszillator
'              CKSEL=0100 SUT=10 , JTAG interface enabled (JTAGEN) = 0, sonst
'              interne pull-ups pc5,3 und 2 aktiv !!!!
' Version:     V1.05 08/05
' Portbelegungen:
'
' PORTB                       PORTC                      PORTD
' ------------------------------------------------------------------------------
' Portb.0 = 1wire (DS1820)    Portc.0 = Enable (LCD)     Portd.0 =
' Portb.1 = geht nicht !??    Portc.1 = RS     (LCD)     Portd.1 =
' Portb.2 = Wasser(Heizer)    Portc.2 = Db4    (LCD)     Portd.2 = Int0 von SQW
' Portb.3 = Boden (Heizer)    Portc.3 = Db5    (LCD)     Portd.3 = Int1 DREHGBR -_-
' Portb.4 =                   Portc.4 = Db6    (LCD)     Portd.4 = DREHGBR _-_
' Portb.5 =                   Portc.5 = Db7    (LCD)     Portd.5 = Sda (DS1307)
' Portb.6 = im STK500 nicht ! Portc.6 =                  Portd.6 = Taste DRGBR
' Portb.7 = im STK500 nicht ! Portc.7 =                  Portd.7 = Scl (DS1307)
'
' "DREHGBR" bezeichnet im Programmm den Drehgeber
'
' Portb.6 und Portb.7 sind beim STK500 und Verendung des Atmega 8 nicht
' verwendbar !! Die Pind sind nicht auf die Sockelleisten gefhrt (Xt1 Xt2),
' jedoch an die "Expand 1 un 0 Leiste.
' Also vorsicht, wenn mit internem Taktgeber gearbeitet wird und die freiwerdenden
' PB6(pin9) und PB7(pin10) verwendet werden sollen.....
' ------------------------------------------------------------------------------
'
' ASCII   HEX   Symbol
'
' 13      0D     CR     Linefeed
' 10      0A     LF     Carriage Return
'
'
'
'
'
'*******************************************************************************
'Wer das Vorgehen String=String+Zeichen nicht mag, kann mit einem kleinen Trick
Optimal Vorgehen : In Bascom Ist Es Mglich , Ein Und Denselben Sram -platz Mit
Mehreren Variablen Zu Belegen. Wir Knnen Z.b. Anweisen , Da Unsere
String -variable Auf Adresse &H60 Gesetzt Werden Soll. Gleichzeitig Knnen Wir
Ein Feld Mit 11 Bytes Dimensionieren , Das Auf Der Gleichen Adresse Liegen Soll
(ein 10 Byte Langer String Bentigt 11 Bytes Platz). Damit Knnen Wir Ganz
Einfach Und Effizient ber Vllig Verschiedene Methoden Auf Denselben Speicher
Zugreifen. Schauen Sie Sich Bitte Das Folgende Listing An.

Der String Wird Auf Adresse &H60 Im Avr Abgelegt. Dies Ist Die Adresse Des
Ersten Bytes Im Sram(da Der At90s2313 ber 128 Bytes Sram Vefgt ,
Ist Die Hchste Sram -adresse &HDF). Quasi "darber" , Also Auf Die Selbe Adresse
Legen Wir Ein Feld , Das Genauso Lang Wie Der String Ist.
Das Ist Alles. Der Trick Ist Nur , Da Wir Beim Fllen Des Strings In Unserem
Anwendungsfall Am Effizientesten Mit Einem Feld Arbeiten Knnen.
Whrend In Anderen Fllen Die Arbeit Mit Einem String Gnstiger Sein Kann.
Welche Wege Man In Der Praxis Gehen Will , Hngt Natrlich Immer Von Der Anwendung Ab
Die Anwendung Des Overlay -tricks Kostet Weder Zustzlichen Code , Noch Sram.
Es Ist Vielleicht Eher Wie Die Auswahl Zwischen Buddelschippe , Schaufel Und Bagger
Bei Ein Und Dem Selben Haufen Sand.

Und Noch Ein Drittes Uart -miverstndnis Trat Wiederholt Auf:
Der Uart -empfangs -interrupt Meldet , Da Ein Zeichen Empfangen Wurde.
In der Interrupt-Routine kann man deshalb auch immer nur ein Zeichen auslesen.
Zum Beispiel Macht Es Daher Keinen Sinn , In Der Interrupt -routine Den Bascom -befehl
Input Einzusetzen , Um Doch Mehrere Zeichen Empfangen Zu Knnen.
'*******************************************************************************

Dim S As String * 10 At &H60
Dim B(11) As Byte At &H60 Overlay

       "String (up to 254 bytes)."
Strings Are Stored As Bytes And Are Terminated With A 0 -byte.
A String Dimensioned With A Length Of 10 Bytes Will Occupy 11 Bytes ""

Dim N As Byte

On Urxc Onrxd
Enable Urxc
Enable Interrupts

Main:
  If N > 9 Then
    Print S
    N = 0
  End If
Goto Main

Onrxd:
  Incr N
  B(n) = Udr
Return
'*******************************************************************************

')
$regfile = "M16DEF.DAT"
$baud = 300
$crystal = 8000000                                          'interner RC Oszillator
Config Lcd = 20 * 4
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0

                                       'a flag for signalling a received character
Dim Serbuff As String * 100 At &H60
Dim B(101) As Byte At &H60 Overlay

'"String (up to 254 bytes)."
'Strings Are Stored As Bytes And Are Terminated With A 0 -byte.
'A String Dimensioned With A Length Of 10 Bytes Will Occupy 11 Bytes ""

Dim N As Byte
Dim Request As Bit
Dim Response As Bit
Dim Lf As Bit
Dim Char_in As Bit
N = 0
Request = 0
Response = 0
Reset Char_in
Lf = 0
Locate 1 , 1
Lcd "HTTP-Server 1.0"
Cls
Wait 1
Lcd "HTTP-Server 1.0"
Print "Reset erfolgt"

On Urxc Onrxd
Enable Urxc
Enable Interrupts


Main:
'Locate 2 , 1
'Lcd N ; "  " ; Lf

If Char_in = 1 Then
         Disable Serial
         Print "char empfangen" ; B(n)

         If Lf = 1 Then
             Reset Lf
             Print "LF empfangen"

             If N > 99 Then
                N = 0
                Print " n> 99!!!"
                Reset Request
                Reset Response

             End If


             If B(1) = 71 And B(2) = 69 And B(3) = 84 And B(4) = 32 And B(5) = 47 And B(6) = 13 And B(7) = 10 Then
                Set Request
                Print "GET / empfangen"
             End If

             If Request = 1 Then                            'And N = 2
                      Set Response
                      'Locate 3 , 1
                      Print "Leerzeile empfangen"
                      'Locate 4 , 1
                      Print "Response"
                      Reset Request

             End If


           N = 0

         End If
Reset Char_in
Enable Serial
End If

  If Response = 1 Then
     'Disable Serial
     Print "HTTP/1.1 200 OK"
     Print "Connection: close"
     Print "Content-type: text/html"
     Print
     Print "<h1>Antwort</h1>"
     Print "<p>Ich bin eine Antwort1</p>"
     Print
     Print Chr(13)
     Print Chr(10)

     Print "HTTP/1.1 200 OK"
     Print "Connection: close"
     Print "Content-type: text/html"
     Print
     Print "<h1>Antwort</h1>"
     Print "<p>Ich bin eine Antwort1</p>"
     Print
     Print Chr(13)
     Print Chr(10)

     Print "HTTP/1.1 200 OK"
     Print "Connection: close"
     Print "Content-type: text/html"
     Print
     Print "<h1>Antwort</h1>"
     Print "<p>Ich bin eine Antwort1</p>"
     Print
     Print Chr(13)
     Print Chr(10)

     Reset Response
     'Enable Serial

  End If

Goto Main

Onrxd:
  Incr N
  B(n) = Udr
  If B(n) = 10 Then Set Lf
  Set Char_in
  'Print B(n)
Return